import parser._
import fun._

// Resposta da questão 2 da lista 4
val plista = ProgFun.parse(
"""
  fun Cons(h, t)
    fun (v, c)
      c(h, t)
    end
  end

  fun Vazia()
    fun (v, c)
      v()
    end
  end

  fun tamanho(l)
    l(fun () 0 end,
      fun (h, t) 1 + tamanho(t) end)
  end

  fun map(f, l)
    l(fun () l end,
      fun (h, t) Cons(f(h), map(f, t)) end)
  end

  fun filter(p, l)
    l(fun () l end,
      fun (h, t)
         if p(h) then
           Cons(h, filter(p, t))
         else
           filter(p, t)
         end
      end)
  end

  fun foldLeft(z, op, l)
    l(fun () z end,
      fun (h, t) foldLeft(op(z, h), op, t) end)
  end

  fun foldRight(z, op, l)
    l(fun () z end,
      fun (h, t) op(h, foldRight(z, op, t)) end)
  end

  fun concat(l1, l2)
    foldRight(l2,
              fun (h, t) Cons(h, t) end,
              l1)
  end

  fun flatMap(f, l)
    l(fun () l end,
      fun (h, t)
        concat(f(h), flatMap(f, t))
      end)
  end

  foldRight(0, fun (a, b) a + b end,
           flatMap(fun (x) Cons(x + x, Vazia()) end,
           filter(fun (x) x < 3 end, Cons(1, Cons(2, Cons(3, Vazia()))))))
"""
)
eval(plista)
